#include <string>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
int n, m, l;
vector<vector<int>> al;
vector<int> used;

int pack(int x, int y, int i) {
	return (((x << 8) | y) << 8) | i;
}

pair<int, int> unpack(int u) {
	u >>= 8;
	return { u >> 8, u & 255 };
}

const int dx[4] = { 0, 0, -1, 1 };
const int dy[4] = { -1, 1, 0, 0 };

vector<int> st;
vector<int> cycle;
vector<string> field;
vector<pair<int, int>> ans;

char getdir(pair<int, int> &a, pair<int, int> &b) {
	if (b.first == a.first + 1) {
		return 'D';
	}
	if (b.first == a.first - 1) {
		return 'U';
	}
	if (b.second == a.second + 1) {
		return 'R';
	}
	return 'L';
}

void dfs(int u) {
	used[u] = 1;
	st.push_back(u);
	for (int v : al[u]) {
		if (used[v] == 0) {
			dfs(v);
		} else if (used[v] == 1) {
			while (st.back() != v) {
				cycle.push_back(st.back());
				st.pop_back();
			}
			cycle.push_back(st.back());
			st.pop_back();

			reverse(cycle.begin(), cycle.end());

			int frst = 0;
			for (int i = 0; i < cycle.size(); i++) {
				if ((cycle[i] & 255) == 0) {
					frst = i;
				}
			}

			for (int i = 0; i < cycle.size(); i++) {
				ans.push_back(unpack(cycle[(i + frst) % cycle.size()]));
			}

			//for (auto p : ans) {
			//	cout << p.first + 1 << " " << p.second + 1 << endl;
			//}

			string res = "";

			for (int i = 0; i + 1 < ans.size(); i++) {
				res.push_back(getdir(ans[i], ans[i + 1]));
			}
			res.push_back(getdir(ans.back(), ans[0]));

			cout << "YES" << endl;
			cout << res.length() << endl;
			cout << ans[0].first + 1 << " " << ans[0].second + 1 << endl;
			cout << res << endl;

			exit(0);
		}
	}
	used[u] = 2;
	st.pop_back();
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m >> l;
	int sz = 256 * 256 * 256;
	field.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> field[i];
	}
	string pattern;
	cin >> pattern;
	al.resize(sz);
	used.resize(sz);

	for (int x = 0; x < n; x++) {
		for (int y = 0; y < m; y++) {
			for (int i = 0; i < l; i++) {
				int u = pack(x, y, i);
				int ii = (i + 1) % l;
				for (int d = 0; d < 4; d++) {
					int xx = x + dx[d];
					int yy = y + dy[d];
					if (0 <= xx && xx < n && 0 <= yy && yy < m && field[xx][yy] == pattern[ii]) {
						al[u].push_back(pack(xx, yy, ii));
					}
				}
			}
		}
	}

	for (int i = 0; i < sz; i++) {
		if (used[i] == 0) {
			dfs(i);
		}
	}

	cout << "NO" << endl;

	return 0;
}