#include <vector>
#include <iostream>
#include <algorithm>
#include <numeric>

using namespace std;
typedef long long nagai;

struct fr
{
	nagai n, m;
	int id;
	fr(nagai n, nagai m, int id)
		: n(n), m(m), id(id)
	{}
	fr(){}
	bool operator <(fr b) const
	{
		if (b.m * m < 0)
			return n * b.m > m * b.n;
		return n * b.m < m * b.n;
	}
	fr operator -(fr b) const
	{
		return fr(n * b.m - b.n * m, m * b.m, id * 6000 + b.id);
	}
	fr med(fr b)
	{
		return fr(n + b.n, m + b.m, id * 3000 + b.id);
	}
};

nagai INF = 1000000000;

int main()
{
	int n; cin >> n;
	vector<fr> frs(n);
	for (int i = 0; i < n; ++i)
		cin >> frs[i].n >> frs[i].m, frs[i].id = i;
	sort(frs.begin(), frs.end());
	vector<vector<fr>> prmax(n, vector<fr>(n + 1, fr(-INF, 1, -1))), mxi(n, vector<fr>(n + 1, fr(-1, -1, -1))), med(n, vector<fr>(n));
	fr ans = { -INF, 1, -1 };
	fr ansi = { -1, -1, -1 };
	pair<int, int> ansj = { -1, -1 };
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
		{
		med[i][j] = i <= j ? fr(-INF, 1, -1) : frs[i].med(frs[j]);
		prmax[i][j + 1] = prmax[i][j];
		mxi[i][j + 1] = mxi[i][j];
		if (prmax[i][j + 1] < med[i][j])
			prmax[i][j + 1] = med[i][j], mxi[i][j + 1] = { frs[i].id, frs[j].id, -1 };
		}

	for (int i4 = 0; i4 < n; ++i4)
	{
		fr curmx = { -INF, 1, -1 }; 
		fr curi = { -1, -1, -1 };
		for (int j = 0; j < i4; j++) {
			if (curmx < prmax[j][i4]) {
				curmx = prmax[j][i4];
				curi = mxi[j][i4];
			}
		}
		for (int i2 = i4 + 1; i2 < n; ++i2)
		{
			if (ans < curmx - med[i2][i4])
				ans = curmx - med[i2][i4], ansi = curi, ansj = { frs[i2].id, frs[i4].id };
			if (curmx < prmax[i2][i4]) {
				curmx = prmax[i2][i4];
				curi = mxi[i2][i4];
			}
		}
	}
	cout << ansi.n + 1 << ' ' << ansj.first + 1 << ' ' << ansi.m + 1 << ' ' << ansj.second + 1 << endl;
	system("pause");
}
/*
4
1 1
1 2
2 3
6 11
*/