import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class I {
	public void solve() throws IOException {
		int n = nextInt(), m = nextInt();
		int[] first = new int[m];
		int[] second = new int[m];
		for (int i = 0; i < m; i++) {
			first[i] = nextInt() - 1;
			second[i] = nextInt() - 1;
		}
		int[] ordered = order(first, second, n, m);
		if (ordered == null) {
			out.println(-1);
			return;
		}
		int[] next = new int[n];
		Arrays.fill(next, -1);
		for (int i = 0; i < n - 1; i++) {
			next[ordered[i]] = ordered[i + 1];
		}
		boolean[] f = new boolean[n];
		int z = n - 1;
		for (int i = 0; i < m; i++) {
			if (next[first[i]] != second[i]) {
				continue;
			}
			if (f[first[i]]) {
				continue;
			}
			f[first[i]] = true;
			z--;
			if (z == 0) {
				out.println(i + 1);
				return;
			}
		}
	}
	
	public int[] order(int[] first, int[] second, int n, int m) {
		TreeMap<Integer, TreeSet<Integer>> lines = new TreeMap<>();
		int[] a = new int[n];
		int[] res = new int[n];
		boolean[] f = new boolean[n];
		int z = n;
		for (int i = 0; i < n; i++) {
			lines.put(i, new TreeSet<>());
		}
		for (int i = 0; i < m; i++) {
			lines.get(first[i]).add(second[i]);
			z -= a[second[i]] == 0 ? 1 : 0;
			a[second[i]]++;
		}
		for (int k = 0; k < n; k++) {
			if (z > 1) {
				return null;
			}
			z--;
			for (int i = 0; i < n; i++) {
				if (a[i] != 0 || f[i]) {
					continue;
				}
				f[i] = true;
				res[k] = i;
				for (int j : lines.get(i)) {
					a[j]--;
					z += a[j] == 0 ? 1 : 0;
				}
				break;
			}
		}
		return res;
	}
	
	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new I().run();
	}

}

/*
5 5
5 1
3 2
2 4
4 5
3 5

5 5
5 2
3 1
1 4
4 5
3 5

*/