#include <iostream>
#include <vector>
#include <cstring>
#include <sstream>

using namespace std;

typedef long long ll;

const int x = 37;
const int MOD = 1e9 + 7;
const int MAXN = 5e3;

int x_pow[MAXN];

void init_pow() {
	x_pow[0] = 1;
	for (int i = 1; i < MAXN; i++)
		x_pow[i] = ((ll)x_pow[i - 1] * (ll)x) % MOD;
}

struct my_string {
	int n;
	string s;
	int h[MAXN + 1];
	my_string(string s = "") : n(int(s.length())), s(s) {
		h[0] = 0;
		for (int i = 1; i <= n; i++)
			h[i] = ((ll)h[i - 1] * x + s[i - 1]) % MOD;
	}

	inline int hash(int i, int j) {
		return (h[j + 1] - ((ll)h[i] * x_pow[j - i + 1]) % MOD + MOD) % MOD;
	}
};

bool dp[MAXN];

vector <int> y;

int main() {
	//freopen("input.txt", "r", stdin);
	int n; cin >> n;
	string s1, s2; cin >> s1 >> s2;
	
	init_pow();

	my_string m1(s1), m2(s2);

	dp[0] = true;
	y.push_back(0);
	for (int i = 1; i <= n; i++) {
		dp[i] = false;
		for (int j : y) {
			if (m1.hash(j, i - 1) == m2.hash(m2.n - i, m2.n - j - 1))
				dp[i] |= dp[j];
			if (dp[i])
				break;
		}
		if (dp[i])
			y.push_back(i);
	}

	if (dp[n])
		cout << "Yes" << endl;
	else
		cout << "No" << endl;

	return 0;
}