import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by spb on 23.10.2016.
 */
public class TaskF {

    String fileName = "";

    public void solve() throws IOException {
        int k = nextInt();
        Fraction[] f = new Fraction[k];
        for (int i = 0; i < k; i++) {
            f[i] = new Fraction(nextInt(), nextInt(), i + 1);
        }
        Arrays.sort(f);

        double res = Double.MIN_VALUE;
        int t1 = 0, t2 = 0;
        for (int i = 0; i < k - 1; i++) {
            for (int j = 0; j < i - 1; j++) {
                if (med(f[j], f[i]).value() - med(f[j + 1], f[i + 1]).value() >= res) {
                    res = med(f[j], f[i]).value() - med(f[j + 1], f[i + 1]).value();
                    t1 = i;
                    t2 = j;
                }
            }
        }

        out.println(f[t2].idx + " " + f[t2 + 1].idx + " " + f[t1].idx + " " + f[t1 + 1].idx);
    }

    Fraction med(Fraction a, Fraction b) {
        return new Fraction(a.p + b.p, a.q + b.q, -1);
    }

    class Fraction implements Comparable<Fraction> {
        long p, q;
        int idx;

        public Fraction(long p, long q, int idx) {
            this.p = p;
            this.q = q;
            this.idx = idx;
        }

        double value() {
            return (double) p / q;
        }

        @Override
        public int compareTo(Fraction o) {
            return Long.compare(p * o.q, q * o.p);
        }
    }

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out, true);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskF().run();
    }

}
