import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class TaskI {
    String fileName = "";

    ArrayList<Integer>[] graph;

    public void solve() throws IOException {
        int n = nextInt(), m = nextInt();
        graph = new ArrayList[n];
        HashMap<Integer, Integer>[] map = new HashMap[n];
        for (int i = 0; i < n; i++) {
            graph[i] = new ArrayList<>();
            map[i] = new HashMap<>();
        }

        for (int i = 0; i < m; i++) {
            int u = nextInt() - 1, v = nextInt() - 1;
            graph[u].add(v);
            map[u].put(v, i);
        }

        vis = new boolean[n];
        time = new int[n];
        int[] res = new int[n];
        tlast = 0;
        for (int i = 0; i < n; i++) {
            if (!vis[i]) {
                topsort(i);
            }
        }
        for (int i = 0; i < n; i++) {
            res[time[i]] = i;
        }
        int r = 0;
        for (int i = 0; i < n - 1; i++) {
            if (!graph[res[i + 1]].contains(res[i])) {
                out.println(-1);
                return;
            } else {
                r = Math.max(r, map[res[i + 1]].get(res[i]));
            }
        }
        out.println(r + 1);
    }
    /*
5 5
5 1
3 2
2 4
4 5
3 5
     */

    boolean[] vis;
    int[] time;
    int tlast;

    public void topsort(int v) {
        vis[v] = true;
        for (int u : graph[v]) {
            if (!vis[u]) {
                topsort(u);
            }
        }
        time[v] = tlast;
        tlast++;
    }

    class Next {
        int v, time;

        public Next(int v, int time) {
            this.v = v;
            this.time = time;
        }
    }

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskI().run();
    }

}
